#!/usr/bin/perl
###
$Limit{sitemap}=50000;
$Limit{atom}=20;
$Limit{rss1}=20;
$Limit{rss2}=20;
$Summary=1;
$TimeZone='+09:00';
###
use DBI;
use Compress::Zlib;
###
require "package/ReadForm.pl";
require "package/UrlMake.pl";
###
die if($FORM{bid}=~/\D/);
&Atom if($FORM{type} eq 'atom');
&Rss1 if($FORM{type} eq 'rss1');
&Rss2 if($FORM{type} eq 'rss2');
&Sitemapindex if($FORM{type} eq 'sitemapindex');
&Sitemap;
###
sub Rss2{
	my($dbh,$sth,$ref,$xml,$bid,$bt,$ut,$bn,$an,$bd,@time,$url,@url,%title,%summary,%date);
	$bid=$FORM{bid};
	$dbh=DBI->connect("dbi:SQLite:dbname=bloglist.db");
	$sth=$dbh->prepare("select BlogTop,UrlType,BlogName,AuthorName,Description from BlogList where BlogId=$bid");
	$sth->execute;
	$ref=$sth->fetch;
	$bt=$ref->[0];
	$ut=$ref->[1];
	$bn=$ref->[2];
	$an=$ref->[3];
	$bd=$ref->[4];
	$sth->finish;
	$dbh->disconnect;
	$dbh=DBI->connect("dbi:SQLite:dbname=entry/$bid.db");
	$sth=$dbh->prepare("select EntryId,EntryTime,EntryTitle,Summary from EntryList order by EntryTime desc limit $Limit{rss2}");
	$sth->execute;
	while($ref=$sth->fetch){
		$url=&UrlMake::make($bid,$bt,$ut,"type=entry,eid=$ref->[0]");
		push(@url,$url);
		if($Summary && $ref->[3]){
			$summary{$url}=$ref->[3];
		}
		$title{$url}=$ref->[2];
		@time=$ref->[1]=~/(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})/;
		$date{$url}="$time[0]-$time[1]-$time[2]T$time[3]:$time[4]:$time[5]$TimeZone";
	}
	$sth->finish;
	$dbh->disconnect;
	
	$xml="<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
	$xml.="<rss version=\"2.0\" xmlns:dc=\"http://purl.org/dc/elements/1.1/\">";
	$xml.="<channel>";
	$xml.="<title>$bn</title>";
	$xml.="<link>$bt</link>";
	$xml.="<description>$bd</description>";
	foreach(@url){
		$xml.="<item>";
		$xml.="<title>$title{$_}</title>";
		$xml.="<link>$_</link>";
		$xml.="<description>$summary{$_}</description>";
		$xml.="<dc:date>$date{$_}</dc:date>";
		$xml.="</item>\n";
	}
	$xml.="</channel></rss>";
	&PrintXml(\$xml);
}
###
sub Rss1{
	my($dbh,$sth,$ref,$xml,$bid,$bt,$ut,$bn,$an,$bd,@time,$url,@url,%title,%summary,%date);
	$bid=$FORM{bid};
	$dbh=DBI->connect("dbi:SQLite:dbname=bloglist.db");
	$sth=$dbh->prepare("select BlogTop,UrlType,BlogName,AuthorName,Description from BlogList where BlogId=$bid");
	$sth->execute;
	$ref=$sth->fetch;
	$bt=$ref->[0];
	$ut=$ref->[1];
	$bn=$ref->[2];
	$an=$ref->[3];
	$bd=$ref->[4];
	$sth->finish;
	$dbh->disconnect;
	$dbh=DBI->connect("dbi:SQLite:dbname=entry/$bid.db");
	$sth=$dbh->prepare("select EntryId,EntryTime,EntryTitle,Summary from EntryList order by EntryTime desc limit $Limit{rss1}");
	$sth->execute;
	while($ref=$sth->fetch){
		$url=&UrlMake::make($bid,$bt,$ut,"type=entry,eid=$ref->[0]");
		push(@url,$url);
		if($Summary && $ref->[3]){
			$summary{$url}=$ref->[3];
		}
		$title{$url}=$ref->[2];
		@time=$ref->[1]=~/(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})/;
		$date{$url}="$time[0]-$time[1]-$time[2]T$time[3]:$time[4]:$time[5]$TimeZone";
	}
	$sth->finish;
	$dbh->disconnect;
	
	$xml="<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
	$xml.="<rdf:RDF xmlns=\"http://purl.org/rss/1.0/\" xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" xmlns:dc=\"http://purl.org/dc/elements/1.1/\">";
	$xml.="<channel rdf:about=\"$bt\">";
	$xml.="<title>$bn</title>";
	$xml.="<link>$bt</link>";
	$xml.="<description>$bd</description>";
	$xml.="<items><rdf:Seq>";
	foreach(@url){
		$xml.="<rdf:li rdf:resource=\"$_\"/>";
	}	
	$xml.="</rdf:Seq></items></channel>\n";
	foreach(@url){
		$xml.="<item rdf:about=\"$_\">";
		$xml.="<title>$title{$_}</title>";
		$xml.="<link>$_</link>";
		$xml.="<description>$summary{$_}</description>";
		$xml.="<dc:date>$date{$_}</dc:date>";
		$xml.="</item>\n";
	}
	$xml.="</rdf:RDF>";
	&PrintXml(\$xml);
}
###
sub Atom{
	my($dbh,$sth,$ref,$xml,$bid,$bt,$ut,$bn,$an,@time,$url,$title,$author,$summary);
	$bid=$FORM{bid};
	$dbh=DBI->connect("dbi:SQLite:dbname=bloglist.db");
	$sth=$dbh->prepare("select BlogTop,UrlType,BlogName,AuthorName from BlogList where BlogId=$bid");
	$sth->execute;
	$ref=$sth->fetch;
	$bt=$ref->[0];
	$ut=$ref->[1];
	$bn=$ref->[2];
	$an=$ref->[3];
	$sth->finish;
	$dbh->disconnect;
	
	$xml="<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<feed xmlns=\"http://www.w3.org/2005/Atom\">";
	if($bt){
		if(!$ut){
			$url=$bt."index.cgi?bid=$bid";
		}
		$xml.="<title>$bn</title>";
		$xml.="<link href=\"$bt\"/>";
		$xml.="<id>$bt</id>";
		if($an){
			$xml.="<author><name>$an</name></author>";
		}
		$dbh=DBI->connect("dbi:SQLite:dbname=entry/$bid.db");
		$sth=$dbh->prepare("select EntryId,EntryTime,EntryTitle,Summary from EntryList order by EntryTime desc limit $Limit{atom}");
		$sth->execute;
		while($ref=$sth->fetch){
			$url=&UrlMake::make($bid,$bt,$ut,"type=entry,eid=$ref->[0]");
			$summary="";
			if($Summary && $ref->[3]){
				$summary="<summary>$ref->[3]</summary>";
			}
			@time=$ref->[1]=~/(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})/;
			$xml.="<entry><title>$ref->[2]</title><link href=\"$url\"/><id>$url</id><updated>$time[0]-$time[1]-$time[2]T$time[3]:$time[4]:$time[5]$TimeZone</updated>$summary</entry>";
		}
		$sth->finish;
		$dbh->disconnect;
	}
	$xml.="</feed>";
	&PrintXml(\$xml);
}
###
sub Sitemapindex{
	my($dbh,$sth,$ref,$xml,$bid,$bt,$count,$s);
	$bid=$FORM{bid};
	$dbh=DBI->connect("dbi:SQLite:dbname=bloglist.db");
	$sth=$dbh->prepare("select BlogTop,EntryCount from BlogList where BlogId=$bid");
	$sth->execute;
	$ref=$sth->fetch;
	$bt=$ref->[0];
	$count=$ref->[1];
	$sth->finish;
	$dbh->disconnect;
	$s=int(($count-1)/$Limit{sitemap});
	$xml="<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<sitemapindex xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">\n";
	for(0..$s){
		$xml.="<sitemap><loc>${bt}feed.cgi?bid=$bid&amp;type=sitemap&amp;num=$_</loc></sitemap>\n";
	}
	$xml.="</sitemapindex>";
	&PrintGzip(\$xml);
}
###
sub Sitemap{
	my($dbh,$sth,$ref,$xml,$bid,$num,$bt,$ut,@time,$url);
	$bid=$FORM{bid};
	$num=$FORM{num}||0;
	$dbh=DBI->connect("dbi:SQLite:dbname=bloglist.db");
	$sth=$dbh->prepare("select BlogTop,UrlType from BlogList where BlogId=$bid");
	$sth->execute;
	$ref=$sth->fetch;
	$bt=$ref->[0];
	$ut=$ref->[1];
	$sth->finish;
	$dbh->disconnect;
	$xml="<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">\n";
	if($bt){
		$dbh=DBI->connect("dbi:SQLite:dbname=entry/$bid.db");
		$sth=$dbh->prepare("select EntryId,EntryTime from EntryList order by EntryTime desc limit $Limit{sitemap} offset ".($num*$Limit{sitemap}));
		$sth->execute;
		while($ref=$sth->fetch){
			$url=&UrlMake::make($bid,$bt,$ut,"type=entry,eid=$ref->[0]");
			@time=$ref->[1]=~/(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})/;
			$xml.="<url><loc>$url</loc><lastmod>$time[0]-$time[1]-$time[2]T$time[3]:$time[4]:$time[5]$TimeZone</lastmod></url>";
		}
		$sth->finish;
		$dbh->disconnect;
	}
	$xml.="</urlset>";
	&PrintGzip(\$xml);
}
###
sub PrintXml{
	my(@time);
	@time=gmtime((stat("cache/reconstruction.$FORM{bid}.dat"))[9]);
	for(0..3){
		$time[$_]='0'.$time[$_] if(length($time[$_])==1);
	}
	$time[4]=("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec")[$time[4]];
	$time[5]+=1900;
	$time[6]=("Sun","Mon","Tue","Wed","Thu","Fri","Sat")[$time[6]];
	$time[7]="$time[6], $time[3] $time[4] $time[5] $time[2]:$time[1]:$time[0] GMT";
	print "content-type:application/xml\nLast-Modified: $time[7]\n";
	if($ENV{HTTP_ACCEPT_ENCODING}=~/gzip/){
		print "Content-Encoding:gzip\n\n".Compress::Zlib::memGzip(${$_[0]});
	}else{
		print "\n".${$_[0]};
	}
	exit;
}
###
sub PrintGzip{
	my(@time);
	@time=gmtime((stat("cache/reconstruction.$FORM{bid}.dat"))[9]);
	for(0..3){
		$time[$_]='0'.$time[$_] if(length($time[$_])==1);
	}
	$time[4]=("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec")[$time[4]];
	$time[5]+=1900;
	$time[6]=("Sun","Mon","Tue","Wed","Thu","Fri","Sat")[$time[6]];
	$time[7]="$time[6], $time[3] $time[4] $time[5] $time[2]:$time[1]:$time[0] GMT";
	print "content-type:application/x-gzip\nLast-Modified: $time[7]\n";
	print "Content-Disposition: attachment; filename=\"sitemap.xml.gz\"\n\n";
	print Compress::Zlib::memGzip(${$_[0]});
	exit;
}
###

