#!/usr/bin/perl
###
$Var{Ver}='whblog 1.7';
$Var{OHP}='http://whblog.stsd.info/';
###
$MaxCache=100_000_000;
$MaxSearch=10_000_000;
$CacheType='BLOB';
$Template='default';
$MobileTemplate='chtml';
$MobileListLength=10;
###
require "package/ReadForm.pl";
require "package/UrlMake.pl";
require "package/UrlEncode.pl";
require "package/MetaEscape.pl";
###
use DBI;
use Compress::Zlib;
use Time::Local;
###
&FastGet if($ARGV[0] eq '-fast');
$BlogId=$FORM{'bid'};
$BlogId=1 if(!$BlogId);
die if($BlogId=~/^\D/ || !-e("entry/$BlogId.db"));
$Var{BlogId}=$BlogId;
$PageType=$FORM{'type'};
$PageType='list' if($PageType ne 'entry' && $PageType ne 'category' && $PageType ne 'month' && $PageType ne 'day' && $PageType ne 'search');
$PageNumber=$FORM{'page'} || 0;
$PageNumber=0 if($PageNumber=~/\D/);
if($PageType eq 'category'){
	$CategoryId=$FORM{'cid'};
	die if($CategoryId=~/^\D/);
	$Var{CategoryId}=$CategoryId;
}
if($PageType eq 'entry'){
	$EntryId=$FORM{'eid'};
	die if($EntryId=~/^\D/);
	$Var{EntryId}=$EntryId;
	$PageNumber=$EntryId;
	$Var{EntryPage}=1;
}
if($PageType eq 'month'){
	$MonthId=$FORM{'month'};
	die if($MonthId=~/^\D/);
}
if($PageType eq 'day'){
	$DayId=$FORM{'day'};
	die if($DayId=~/^\D/);
}
if($FORM{preview} && $FORM{preview}!~/^\./ && $FORM{preview}!~/\// && -d("template/$FORM{preview}")){
	$PreviewMode=1;
	$Template=$FORM{preview};
	$NoCache=1;
}
if($FORM{mobile}){
	$MobileMode=1;
	$Template=$MobileTemplate;
	$NoCache=1;
}
if($PageType eq 'search'){
	$NoCache=1;
	&SearchEntry;
}
$Var{TopPage}=1 if($PageType eq 'list' && !$PageNumber);
$Var{ListPage}=1 if($PageType eq 'list');
$Var{PageType}=$PageType;
$Var{PageNumber}=$PageNumber || 0;
###
&CacheCheck if(!$NoCache);
&DbConnect;
&TempRead;
&PrintPreview if($NoCache);
&CacheRecord if($Result);
&PrintResult;
###
sub FastGet{
	my(@p);
	undef(%FORM);
	foreach(split(/:/,$ARGV[1])){
		@p=split(/=/,$_,2);
		$FORM{$p[0]}=$p[1];
	}
}
###
sub SearchEntry{
	my($dbh,$sth,$dbe,$ste,$ref,$str,$key,$le,%list,%match);
	if(!-s("search/$BlogId.db")){
		open(LOCK,"cache/reconstruction.$BlogId.dat");
		flock(LOCK,1);
		if(!-s("search/$BlogId.db")){
			$dbh=DBI->connect("dbi:SQLite:dbname=search/$BlogId.db");
			$dbh->do("create table SearchIndex(SearchWord text primary key,EntryList text,LastEntry int)");
			$dbh->disconnect;
		}
		close(LOCK);
	}
	$str=$FORM{str};
	&UrlEncode::decode(\$str);
	$str=~s/　/ /g;
	$str=~s/\s+/ /g;
	$str=~s/^\s+//g;
	$str=~s/\s+$//g;
	@SearchWord=split(/ /,$str);
	$Var{SearchWord}=$FORM{str};
	&UrlEncode::decode(\$Var{SearchWord});
	&MetaEscape::html(\$Var{SearchWord});
	$dbh=DBI->connect("dbi:SQLite:dbname=search/$BlogId.db");
	$dbe=DBI->connect("dbi:SQLite:dbname=entry/$BlogId.db");
	for(my $i=0;$i<=$#SearchWord;$i++){
		$str=$SearchWord[$i];
		$key=$str;
		&UrlEncode::encode(\$key);
		$le=0;
		undef(%list);
		$sth=$dbh->prepare("select EntryList,LastEntry from SearchIndex where SearchWord='$key'");
		$sth->execute;
		if($ref=$sth->fetch){
			foreach(split(/,/,$ref->[0])){
				$list{$_}=1;
				$match{$_}++;
			}
			$le=$ref->[1];
		}
		$sth->finish;
		$ste=$dbe->prepare("select EntryId,EntryTitle,EntryBody,EntryMore from EntryList where EntryId>$le");
		$ste->execute;
		while($ref=$ste->fetch){
			if($ref->[1]=~/$str/ || $ref->[2]=~/$str/ || $ref->[3]=~/$str/){
				$list{$ref->[0]}=1;
				$match{$ref->[0]}++;
			}
		}
		$ste->finish;
		$ste=$dbe->prepare("select seq from sqlite_sequence");
		$ste->execute;
		$ref=$ste->fetch;
		$le=$ref->[0];
		$ste->finish;
		$dbh->do("replace into SearchIndex(SearchWord,EntryList,LastEntry) values('$key','".join(',',keys(%list))."',$le)");
		if($i){
			foreach(keys(%match)){
				next if($match{$_}==$i+1);
				delete($match{$_});
			}
		}
	}
	$dbe->disconnect;
	$dbh->disconnect;
	@MatchEntry=keys(%match);
	$Var{SearchResults}=$#MatchEntry+1;
	if(-s("search/$BlogId.db")>$MaxSearch){
		open(FILE,"+>search/$BlogId.db");
		close(FILE);
	}
}
###
sub TempRead{
	my($temp);
	open(FILE,"template/$Template/html.dat");
	while(<FILE>){
		$temp.=$_;
	}
	close(FILE);
	$Result=&TempMain($temp);
}
###
sub TempMain{
	my($temp,$c,$bool,@exp,$id,$var,$not,$res);
	$temp=shift;
	while(($c=substr($temp,0,1,'')) ne ''){
		if($c eq '&'){
			if($temp=~s/^\$(\w+);//){
				if(exists($Var{$1})){
					$res.=$Var{$1};
				}
			}elsif($temp=~s/^\&(\w+):?(\d*):?([^:;]*);//){
				$id=$2;
				if($1 eq 'EntryLoop'){
					if($id){
						$temp=~s/^(.+?)&\/EntryLoop:$id;//s;
						$res.=&EntryLoop($1);
					}else{
						$temp=~s/^(.+?)&\/EntryLoop;//s;
						$res.=&EntryLoop($1);
					}
				}elsif($1 eq 'CommentLoop'){
					if($id){
						$temp=~s/^(.+?)&\/CommentLoop:$id;//s;
						$res.=&CommentLoop($1);
					}else{
						$temp=~s/^(.+?)&\/CommentLoop;//s;
						$res.=&CommentLoop($1);
					}
				}elsif($1 eq 'TrackbackLoop'){
					if($id){
						$temp=~s/^(.+?)&\/TrackbackLoop:$id;//s;
						$res.=&TrackbackLoop($1);
					}else{
						$temp=~s/^(.+?)&\/TrackbackLoop;//s;
						$res.=&TrackbackLoop($1);
					}
				}elsif($1=~/^PluginLoop(\d+)$/){
					$Var{SidebarId}=$1;
					if($id){
						$temp=~s/^(.+?)&\/PluginLoop$Var{SidebarId}:$id;//s;
						$res.=&PluginLoop($1);
					}else{
						$temp=~s/^(.+?)&\/PluginLoop$Var{SidebarId};//s;
						$res.=&PluginLoop($1);
					}
				}elsif($1 eq 'if'){
					@exp=split(/&/,$3);
					foreach(@exp){
						$bool=0;
						($not,$var)=$_=~/(!?)(.+)/;
						if($var=~/(\w+)=(.*)/){
							$bool=1 if($Var{$1} eq $2);
						}elsif($Var{$var} ne ''){
							$bool=1;
						}
						$bool=!$bool if($not eq '!');
						last if(!$bool);
					}
					if($id){
						$temp=~s/^(.+?)&\/if:$id;//s;
						$res.=&TempMain($1) if($bool);
					}else{
						$temp=~s/^(.+?)&\/if;//s;
						$res.=&TempMain($1) if($bool);
					}
				}
			}else{
				$res.='&';
			}
		}else{
			$res.=$c;
		}
	}
	return($res);
}
###
sub PluginLoop{
	my($temp,$i,$name,$id,$res);
	$temp=shift;
	for($i=0;$Sidebar[$Var{SidebarId}][$i];$i++){
		$Var{PluginLoopCount}=$i;
		($name,$id)=split(/:/,$Sidebar[$Var{SidebarId}][$i]);
		require "plugin/$name.pl" if(!$PluginName{$name});
		($Var{PluginLoopTitle},$Var{PluginLoopBody})=&{$PluginFunc{$name}{html}}($BlogId,$id);
		$res.=&TempMain($temp) if($Var{PluginLoopBody});
	}
	return($res);
}
###
sub CommentLoop{
	return if(!$Var{EntryLoopCommentCount});
	my($temp,$i,$dbh,$sth,$ref,@list,%comment,$res);
	$temp=shift;
	$dbh=DBI->connect("dbi:SQLite:dbname=comment/$BlogId.db");
	$sth=$dbh->prepare("select * from CommentList where EntryId=$Var{EntryLoopId}");
	$sth->execute;
	while($ref=$sth->fetchrow_hashref){
		push(@list,$ref->{CommentId});
		$comment{$ref->{CommentId}}{Name}=$ref->{CommentName};
		$comment{$ref->{CommentId}}{Url}=$ref->{CommentUrl};
		$comment{$ref->{CommentId}}{Body}=$ref->{CommentBody};
		@{$comment{$ref->{CommentId}}{Time}}=$ref->{CommentTime}=~/(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})/;
	}
	$sth->finish;
	$dbh->disconnect;
	for($i=0;$i<=$#list;$i++){
		$Var{CommentLoopCount}=$i;
		$Var{CommentLoopId}=$list[$i];
		$Var{CommentLoopName}=$comment{$list[$i]}{Name};
		$Var{CommentLoopUrl}=$comment{$list[$i]}{Url};
		$Var{CommentLoopBody}=$comment{$list[$i]}{Body};
		$Var{CommentLoopBody}=~s/\n/<br \/>/g;;
		($Var{CommentLoopDateYear},$Var{CommentLoopDateMonth},$Var{CommentLoopDateDay},$Var{CommentLoopDateHour},$Var{CommentLoopDateMinute},$Var{CommentLoopDateSecond})=@{$comment{$list[$i]}{Time}};
		$res.=&TempMain($temp);
	}
	return($res);
}
###
sub TrackbackLoop{
	return if(!$Var{EntryLoopTrackbackCount});
	my($temp,$i,$dbh,$sth,$ref,@list,%trackback,$res);
	$temp=shift;
	$dbh=DBI->connect("dbi:SQLite:dbname=trackback/$BlogId.db");
	$sth=$dbh->prepare("select * from TrackbackList where EntryId=$Var{EntryLoopId}");
	$sth->execute;
	while($ref=$sth->fetchrow_hashref){
		push(@list,$ref->{TrackbackId});
		$trackback{$ref->{TrackbackId}}{BlogName}=$ref->{TrackbackBlogName};
		$trackback{$ref->{TrackbackId}}{Url}=$ref->{TrackbackUrl};
		$trackback{$ref->{TrackbackId}}{Excerpt}=$ref->{TrackbackExcerpt};
		$trackback{$ref->{TrackbackId}}{Title}=$ref->{TrackbackTitle};
		@{$trackback{$ref->{TrackbackId}}{Time}}=$ref->{TrackbackTime}=~/(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})/;
	}
	$sth->finish;
	$dbh->disconnect;
	@list=reverse(@list);
	for($i=0;$i<=$#list;$i++){
		$Var{TrackbackLoopCount}=$i;
		$Var{TrackbackLoopId}=$list[$i];
		$Var{TrackbackLoopBlogName}=$trackback{$list[$i]}{BlogName};
		$Var{TrackbackLoopUrl}=$trackback{$list[$i]}{Url};
		$Var{TrackbackLoopExcerpt}=$trackback{$list[$i]}{Excerpt};
		$Var{TrackbackLoopTitle}=$trackback{$list[$i]}{Title};
		($Var{TrackbackLoopDateYear},$Var{TrackbackLoopDateMonth},$Var{TrackbackLoopDateDay},$Var{TrackbackLoopDateHour},$Var{TrackbackLoopDateMinute},$Var{TrackbackLoopDateSecond})=@{$trackback{$list[$i]}{Time}};
		$res.=&TempMain($temp);
	}
	return($res);
}
###
sub EntryLoop{
	my($temp,$i,$res);
	$temp=shift;
	for($i=0;$i<=$#EntryList;$i++){
		$Var{FirstEntry}="";
		$Var{FirstEntry}=1 if($i==0);
		$Var{EntryLoopCount}=$i;
		$Var{EntryLoopId}=$EntryList[$i];
		$Var{EntryLoopTitle}=$EntryInfo{$EntryList[$i]}{EntryTitle};
		$Var{EntryLoopBody}=$EntryInfo{$EntryList[$i]}{EntryBody};
		$Var{EntryLoopMore}=$EntryInfo{$EntryList[$i]}{EntryMore};
		$Var{EntryLoopTrackbackCount}=$EntryInfo{$EntryList[$i]}{TrackbackCount};
		$Var{EntryLoopCommentCount}=$EntryInfo{$EntryList[$i]}{CommentCount};
		$Var{EntryLoopCategoryId}=$EntryInfo{$EntryList[$i]}{CategoryId};
		$Var{EntryLoopCategoryName}=$CategoryName[$EntryInfo{$EntryList[$i]}{CategoryId}];
		($Var{EntryLoopDateYear},$Var{EntryLoopDateMonth},$Var{EntryLoopDateDay},$Var{EntryLoopDateHour},$Var{EntryLoopDateMinute},$Var{EntryLoopDateSecond})=$EntryInfo{$EntryList[$i]}{EntryTime}=~/(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})/;
		$Var{EntryLoopEntryUrl}=&UrlMake("type=entry,eid=$Var{EntryLoopId}");
		$Var{EntryLoopCategoryUrl}=&UrlMake("type=category,cid=$Var{EntryLoopCategoryId}");
		$res.=&TempMain($temp);
	}
	return($res);
}
###
sub DbConnect{
	my($dbh,$sth,$ref,$i,$last,@clist,@cinfo,@sb,@line);
	$dbh=DBI->connect("dbi:SQLite:dbname=bloglist.db");
	$sth=$dbh->prepare("select * from BlogList where BlogId=$BlogId");
	$sth->execute;
	$ref=$sth->fetchrow_hashref;
	$Var{BlogName}=$ref->{BlogName};
	$BlogTop=$ref->{BlogTop};
	$Var{AuthorName}=$ref->{AuthorName};
	$Var{Description}=$ref->{Description};
	$Var{Keywords}=$ref->{Keywords};
	$UrlType=$ref->{UrlType};
	$Var{BlogTop}=&UrlMake("type=top");
	$Template=$ref->{Template} if(!$PreviewMode && !$MobileMode);
	$Template='default' if(!$Template);
	if($Var{TopPage} && $ref->{TopEntry} && !$MobileMode){
		$Var{TopEntry}=$ref->{TopEntry};
	}
	@list=split(/,/,$ref->{CategoryList});
	foreach(@list){
		@cinfo=split(/:/,$_,3);
		$CategoryName[$cinfo[0]]=$cinfo[2];
	}
	$Var{CategoryName}=$CategoryName[$CategoryId] if($PageType eq 'category');
	$ListLength=10;
	foreach(split(/,/,$ref->{ListLength})){
		@line=split(/:/);
		$line[0]='list' if($line[0] eq 'top');
		$ListLength=$line[1] if($line[1] ne '' && ($PageType eq $line[0] || ($PageType eq 'search' && $line[0] eq 'top')));
	}
	$ListLength=$MobileListLength if($MobileMode);

	@sb=split(/,/,$ref->{Sidebar});
	foreach(@sb){
		@line=split(/:/,$_,2);
		push(@{$Sidebar[$line[0]]},$line[1]);
	}
	$sth->finish;
	$dbh->disconnect;
	$dbh=DBI->connect("dbi:SQLite:dbname=entry/$BlogId.db");
	if($Var{TopEntry}){
		$sth=$dbh->prepare("select * from EntryList where EntryId=$Var{TopEntry}");
		$sth->execute;
		$ref=$sth->fetchrow_hashref;
		push(@EntryList,$ref->{EntryId});
		%{$EntryInfo{$ref->{EntryId}}}=%$ref;
		$sth->finish;
	}elsif($PageType ne 'entry'){
		if($PageType eq 'category'){
			$sth=$dbh->prepare("select * from EntryList where CategoryId=$CategoryId order by EntryTime desc limit $ListLength offset ".($PageNumber*$ListLength));
		}elsif($PageType eq 'month'){
			$sth=$dbh->prepare("select * from EntryList where EntryMonth=$MonthId order by EntryTime desc limit $ListLength offset ".($PageNumber*$ListLength));
		}elsif($PageType eq 'day'){
			$sth=$dbh->prepare("select * from EntryList where EntryDate=$DayId order by EntryTime desc limit $ListLength offset ".($PageNumber*$ListLength));
		}elsif($PageType eq 'search'){
			$sth=$dbh->prepare("select * from EntryList where EntryId in(".join(',',@MatchEntry).") order by EntryTime desc limit $ListLength offset ".($PageNumber*$ListLength));
		}else{
			$sth=$dbh->prepare("select * from EntryList order by EntryTime desc limit $ListLength offset ".($PageNumber*$ListLength));
		}
		$sth->execute;
		while($ref=$sth->fetchrow_hashref){
			push(@EntryList,$ref->{EntryId});
			%{$EntryInfo{$ref->{EntryId}}}=%$ref;
		}
		$sth->finish;
		if($ListLength){
			if($PageType eq 'category'){
				$sth=$dbh->prepare("select EntryId from EntryList where CategoryId=$CategoryId order by EntryTime desc limit 1 offset ".(($PageNumber+1)*$ListLength));
			}elsif($PageType eq 'month'){
				$sth=$dbh->prepare("select EntryId from EntryList where EntryMonth=$MonthId order by EntryTime desc limit 1 offset ".(($PageNumber+1)*$ListLength));
			}elsif($PageType eq 'day'){
				$sth=$dbh->prepare("select EntryId from EntryList where EntryDate=$DayId order by EntryTime desc limit 1 offset ".(($PageNumber+1)*$ListLength));
			}elsif($PageType eq 'search'){
				$sth=$dbh->prepare("select EntryId from EntryList where EntryId in(".join(',',@MatchEntry).") order by EntryTime desc limit 1 offset ".(($PageNumber+1)*$ListLength));
			}else{
				$sth=$dbh->prepare("select EntryId from EntryList order by EntryTime desc limit 1 offset ".(($PageNumber+1)*$ListLength));
			}
			$sth->execute;
			if($ref=$sth->fetch){
				$Var{Next}=$PageNumber+1;
			}
			$sth->finish;
		}
	}else{
		$sth=$dbh->prepare("select * from EntryList where EntryId=$EntryId");
		$sth->execute;
		$ref=$sth->fetchrow_hashref;
		push(@EntryList,$ref->{EntryId});
		%{$EntryInfo{$ref->{EntryId}}}=%$ref;
		$Var{EntryTitle}=$ref->{EntryTitle};
		$Var{EntryCategoryId}=$ref->{CategoryId};
		$sth=$dbh->prepare("select seq from sqlite_sequence");
		$sth->execute;
		$ref=$sth->fetch;
		$last=$ref->[0];
		for($i=$EntryId-1;$i>0;$i--){
			$sth=$dbh->prepare("select EntryTitle from EntryList where EntryId=$i");
			$sth->execute;
			if($ref=$sth->fetchrow_hashref){
				$Var{Next}=$i;
				$Var{NextName}=$ref->{EntryTitle};
				last;
			}
		}
		for($i=$EntryId+1;$i<=$last;$i++){
			$sth=$dbh->prepare("select EntryTitle from EntryList where EntryId=$i");
			$sth->execute;
			if($ref=$sth->fetchrow_hashref){
				$Var{Prev}=$i;
				$Var{PrevName}=$ref->{EntryTitle};
				last;
			}
		}
		$sth->finish;
	}
	$dbh->disconnect;
	if($PageType ne 'entry'){
		$Var{ListLength}=$ListLength;
		$Var{StartNumber}=$ListLength*$Var{PageNumber}+1;
		$Var{LastNumber}=$Var{StartNumber}+$#EntryList;
	}
	$Var{Prev}=$PageNumber-1 if($PageNumber && $PageType ne 'entry');
	if($PageType eq 'category'){
		$Var{NextPageUrl}=&UrlMake("type=category,page=$Var{Next},cid=$CategoryId");
		$Var{PrevPageUrl}=&UrlMake("type=category,page=$Var{Prev},cid=$CategoryId");
	}elsif($PageType eq 'entry'){
		$Var{NextPageUrl}=&UrlMake("type=entry,eid=$Var{Next}");
		$Var{PrevPageUrl}=&UrlMake("type=entry,eid=$Var{Prev}");
	}elsif($PageType eq 'month'){
		$Var{NextPageUrl}=&UrlMake("type=month,month=$MonthId,page=$Var{Next}");
		$Var{PrevPageUrl}=&UrlMake("type=month,month=$MonthId,page=$Var{Prev}");
	}elsif($PageType eq 'day'){
		$Var{NextPageUrl}=&UrlMake("type=day,day=$DayId,page=$Var{Next}");
		$Var{PrevPageUrl}=&UrlMake("type=day,day=$DayId,page=$Var{Prev}");
	}else{
		$Var{NextPageUrl}=&UrlMake("type=$PageType,page=$Var{Next}");
		$Var{PrevPageUrl}=&UrlMake("type=$PageType,page=$Var{Prev}");
	}
}
###
sub CacheCheck{
	my($dbh,$sth,$ref);
	if(-s("cache/reconstruction.$BlogId.dat")){
		open(LOCK,"+<cache/reconstruction.$BlogId.dat");
		flock(LOCK,2);
		if(-s("cache/reconstruction.$BlogId.dat")){
			open(FILE,"+>cache/$BlogId.db");
			close(FILE);
			$dbh=DBI->connect("dbi:SQLite:dbname=cache/$BlogId.db");
			if($CacheType eq 'BLOB'){
				$dbh->do("create table BlogCache(ItemId text primary key,CacheData blob)");
			}else{
				$dbh->do("create table BlogCache(ItemId text primary key,CacheData text)");
			}
			truncate(LOCK,0);
			close(LOCK);
			return;
		}
		close(LOCK);
	}
	if(!-s("cache/$BlogId.db")){
		$dbh=DBI->connect("dbi:SQLite:dbname=cache/$BlogId.db");
		if($CacheType eq 'BLOB'){
			$dbh->do("create table BlogCache(ItemId text primary key,CacheData blob)");
		}else{
			$dbh->do("create table BlogCache(ItemId text primary key,CacheData text)");
		}
		return;
	}
	$dbh=DBI->connect("dbi:SQLite:dbname=cache/$BlogId.db");
	$sth=$dbh->prepare("select CacheData from BlogCache where ItemId='$PageType$CategoryId$MonthId$DayId-$PageNumber'");
	$sth->execute;
	$ref=$sth->fetch;
	if($ref->[0]){
		$Result=$ref->[0];
		$sth->finish;
		$dbh->disconnect;
		&PrintResult;
	}
	$sth->finish;
	$dbh->disconnect;
}
###
sub CacheRecord{
	my($dbh,$sth);
	$Result=Compress::Zlib::memGzip($Result) if($CacheType eq 'BLOB');
	if(-s("cache/$BlogId.db")<$MaxCache){
		open(LOCK,"cache/reconstruction.$BlogId.dat");
		flock(LOCK,1);
		if(!-s("cache/reconstruction.$BlogId.dat")){
			$dbh=DBI->connect("dbi:SQLite:dbname=cache/$BlogId.db");
			if($CacheType eq 'BLOB'){
				$sth=$dbh->prepare("insert into BlogCache(ItemId,CacheData) values('$PageType$CategoryId$MonthId$DayId-$PageNumber',?)");
				$sth->bind_param(1,$Result,DBI::SQL_BLOB);
				$sth->execute;
				$sth->finish;
			}else{
				$dbh->do("insert into BlogCache(ItemId,CacheData) values('$PageType$CategoryId$MonthId$DayId-$PageNumber',$Result)");
			}
			$dbh->disconnect;
		}
		close(LOCK);
	}
}
###
sub PrintResult{
	if($ARGV[0] eq '-fast'){
		if($CacheType ne 'BLOB'){
			print Compress::Zlib::memGzip($Result);
		}else{
			print $Result;
		}
		exit;
	}
	my(@time);
	@time=gmtime((stat("cache/reconstruction.$BlogId.dat"))[9]);
	for(0..3){
		$time[$_]='0'.$time[$_] if(length($time[$_])==1);
	}
	$time[4]=("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec")[$time[4]];
	$time[5]+=1900;
	$time[6]=("Sun","Mon","Tue","Wed","Thu","Fri","Sat")[$time[6]];
	$time[7]="$time[6], $time[3] $time[4] $time[5] $time[2]:$time[1]:$time[0] GMT";
	print "content-type:text/html\nLast-Modified: $time[7]\n";
	if($CacheType ne 'BLOB'){
		print "\n".$Result;
	}elsif($ENV{HTTP_ACCEPT_ENCODING}!~/gzip/){
		print "\n".Compress::Zlib::memGunzip($Result);
	}else{
		print "Content-Encoding:gzip\n\n".$Result;
	}
	exit;
}
###
sub PrintPreview{
	print "content-type:text/html\n";
	if($ENV{HTTP_ACCEPT_ENCODING}=~/gzip/){
		print "Content-Encoding:gzip\n\n".Compress::Zlib::memGzip($Result);
	}else{
		print "\n".$Result;
	}
	exit;
}
###
sub UrlMake{
	return(&UrlMake::make($BlogId,$BlogTop,$UrlType,$_[0],$MobileMode));
}
###

