#!/usr/bin/perl
###
$TimeZone='+09:00';
$MaxFileSize=100_000_000;
###
$ErrorMessage{1}='UsersBlogs is not exists';
$ErrorMessage{2}='Forbidden';
$ErrorMessage{3}='Bad Request';
$ErrorMessage{4}='Entry is not exists';
$ErrorMessage{5}='File is large';
$ErrorMessage{999}='Unknown method';
###
use DBI;
use MIME::Base64;
###
require "package/UrlMake.pl";
require "package/MetaEscape.pl";
###
&methodCall;
###
sub methodCall{
	my($xml,$methodName,$params);
	read(STDIN,$xml,$ENV{'CONTENT_LENGTH'});
	($methodName)=$xml=~/<methodName>\s*([^<\s]+)\s*<\/methodName>/;
	($params)=$xml=~/<params>(.+)<\/params>/s;
	&getUsersBlogs($params) if($methodName eq 'blogger.getUsersBlogs');
	&deletePost($params) if($methodName eq 'blogger.deletePost');

	&getRecentPosts($params) if($methodName eq 'metaWeblog.getRecentPosts');
	&newMediaObject($params) if($methodName eq 'metaWeblog.newMediaObject');
	&newPost($params) if($methodName eq 'metaWeblog.newPost');
	&editPost($params) if($methodName eq 'metaWeblog.editPost');

	&getCategoryList($params) if($methodName eq 'mt.getCategoryList');
	&getRecentPostTitles($params) if($methodName eq 'mt.getRecentPostTitles');
	&getPostCategories($params) if($methodName eq 'mt.getPostCategories');
	&setPostCategories($params) if($methodName eq 'mt.setPostCategories');
	&publishPost($params) if($methodName eq 'mt.publishPost');


	&supportedMethods($params) if($methodName eq 'mt.supportedMethods');

	&PrintError(999);
}
###
sub supportedMethods{
	my($res);	
	$res=<<"EOF";
<?xml version="1.0" encoding="UTF-8"?>
<methodResponse><params><param><value><array><data>
<value><string>blogger.getUsersBlogs</string></value>
<value><string>blogger.deletePost</string></value>
<value><string>metaWeblog.getRecentPosts</string></value>
<value><string>metaWeblog.newMediaObject</string></value>
<value><string>metaWeblog.newPost</string></value>
<value><string>metaWeblog.editPost</string></value>
<value><string>mt.getCategoryList</string></value>
<value><string>mt.getRecentPostTitles</string></value>
<value><string>mt.getPostCategories</string></value>
<value><string>mt.setPostCategories</string></value>
<value><string>mt.publishPost</string></value>
</data></array></value></param></params></methodResponse>
EOF
	&PrintResponse($res);
}
###
sub deletePost{
	my($bid,$eid,$cid,@param,@param2,$dbh,$sth,$ref,$list,$res,$count);	
	while($_[0]=~/<param>\s*<value>(.+?)<\/value>\s*<\/param>/sg){
		push(@param2,$1);
	}
	for(0..3){
		($param[$_])=$param2[$_]=~/<[^>]+>\s*([^<]*?)\s*<\/[^>]+>/;
	}
	($bid,$eid)=$param[1]=~/(\d+)-(\d+)/;
	&UserCheck($bid,$param[2],$param[3]);
	$dbh=DBI->connect("dbi:SQLite:dbname=entry/$bid.db");
	$sth=$dbh->prepare("select CategoryId from EntryList where EntryId=$eid");
	$sth->execute;
	$ref=$sth->fetch;
	$cid=$ref->[0]||0;
	$sth->finish;
	$dbh->do("delete from EntryList where EntryId=$eid");
	$sth=$dbh->prepare("select count(EntryId) from EntryList");
	$sth->execute;
	$ref=$sth->fetch;
	$count=$ref->[0];
	$sth->finish;
	$dbh->disconnect;
	$dbh=DBI->connect("dbi:SQLite:dbname=bloglist.db");
	$dbh->do("update BlogList set EntryCount=$count where BlogId=$bid");
	$dbh->disconnect;
	$res=<<"EOF";
<?xml version="1.0" encoding="UTF-8"?>
<methodResponse><params>
<param><value><boolean>1</boolean></value></param>
</params></methodResponse>
EOF
	&CategoryUpdate($bid,$cid);
	&Reconstruction($bid);
	&PrintResponse($res);
}
###
sub editPost{
	my(@param,$bid,$eid,$name,$pass,%struct,$res);
	while($_[0]=~/<param>(.+?)<\/param>/sg){
		push(@param,$1);
	}
	($bid,$eid)=$param[0]=~/<string>\s*(\d+)-(\d+)\s*<\/string>/;
	($name)=$param[1]=~/<string>\s*(.+)\s*<\/string>/;
	($pass)=$param[2]=~/<string>\s*(.+)\s*<\/string>/;
	while($param[3]=~/<name>\s*([^<\s]+)\s*<\/name>\s*<value>\s*<string>\s*([^<]+?)\s*<\/[^<]+>/g){
		$struct{$1}=$2;
	}
	&PrintError(3) if(!$bid || !$eid || !$struct{title} || !$struct{description});
	&UserCheck($bid,$name,$pass);
	&MetaEscape::unhtml(\$struct{title});
	&MetaEscape::unhtml(\$struct{description});
	&MetaEscape::unhtml(\$struct{mt_text_more});
	&EntryUpdate($bid,$eid,0,$struct{title},$struct{description},$struct{mt_text_more});
	$res=<<"EOF";
<?xml version="1.0" encoding="UTF-8"?>
<methodResponse><params>
<param><value><boolean>1</boolean></value></param>
</params></methodResponse>
EOF
	&PrintResponse($res);
}
###
sub newPost{
	my(@param,$bid,$eid,$name,$pass,%struct,$res);
	while($_[0]=~/<param>(.+?)<\/param>/sg){
		push(@param,$1);
	}
	($bid)=$param[0]=~/<string>\s*(.+)\s*<\/string>/;
	($name)=$param[1]=~/<string>\s*(.+)\s*<\/string>/;
	($pass)=$param[2]=~/<string>\s*(.+)\s*<\/string>/;
	while($param[3]=~/<name>\s*([^<\s]+)\s*<\/name>\s*<value>\s*<string>\s*([^<]+?)\s*<\/[^<]+>/g){
		$struct{$1}=$2;
	}
	&PrintError(3) if(!$bid || !$struct{title} || !$struct{description});
	&UserCheck($bid,$name,$pass);
	&MetaEscape::unhtml(\$struct{title});
	&MetaEscape::unhtml(\$struct{description});
	&MetaEscape::unhtml(\$struct{mt_text_more});
	$eid=&EntryUpdate($bid,0,0,$struct{title},$struct{description},$struct{mt_text_more});
	&CategoryUpdate($bid,0);
	$res=<<"EOF";
<?xml version="1.0" encoding="UTF-8"?>
<methodResponse><params>
<param><value><string>$bid-$eid</string></value></param>
</params></methodResponse>
EOF
	&PrintResponse($res);
}
###
sub newMediaObject{
	my(@param,$b64,$fn,$res,$bt,$ut);
	while($_[0]=~/<param>\s*<value>\s*<[^>]+>\s*([^<]*?)\s*<\/[^>]+>\s*<\/value>\s*<\/param>/g){
		push(@param,$1);
		last if($#param==2);
	}
	$b64=$1 if($_[0]=~s/<base64>([^<]+)<\/base64>//s);
	($fn)=$_[0]=~/<name>\s*name\s*<\/name>\s*<value>\s*<string>\s*([^\s<]+)\s*<\/string>/;
	&PrintError(3) if(!$param[0] || !$fn || !$b64 || $fn=~/^\./ || $fn=~/\//);
	&PrintError(5) if(length($b64)>$MaxFileSize);
	&UserCheck($param[0],$param[1],$param[2]);
	open(FILE,"+>file/$fn");
	print FILE MIME::Base64::decode($b64);
	close(FILE);
	($bt,$ut)=&UrlInfo($param[0]);
	$res=<<"EOF";
<?xml version="1.0" encoding="UTF-8"?>
<methodResponse><params><param><value><struct>
<member><name>url</name><value><string>${bt}file/$fn</string></value></member>
</struct></value></param></params></methodResponse>
EOF
	&PrintResponse($res);
}
###
sub publishPost{
	my($bid,$eid,@param,$res);	
	while($_[0]=~/<param>\s*<value>\s*<[^>]+>\s*([^<]*?)\s*<\/[^>]+>\s*<\/value>\s*<\/param>/g){
		push(@param,$1);
	}
	($bid,$eid)=split(/-/,$param[0]);
	&PrintError(3) if(!$bid || !$eid);
	&UserCheck($bid,$param[1],$param[2]);
	$res=<<"EOF";
<?xml version="1.0" encoding="UTF-8"?>
<methodResponse>
<params><param><value><boolean>1</boolean></value></param></params>
</methodResponse>
EOF
	&Reconstruction($bid);
	&PrintResponse($res);
}
###
sub setPostCategories{
	my($bid,$eid,$cid,$ocid,$params,$array,@param,$dbh,$res);	
	$params=shift;
	$array=$1 if($params=~s/<array>\s*<data>(.+?)<\/data>\s*<\/array>//s);

	while($params=~/<param>\s*<value>\s*<[^>]+>\s*([^<]*?)\s*<\/[^>]+>\s*<\/value>\s*<\/param>/g){
		push(@param,$1);
	}
	$#param=2 if($#param>2);
	($cid)=$array=~/<struct>.*?<name>\s*categoryId\s*<\/name>\s*<value>\s*<string>\s*(\d+?)\s*<\/string>.*?<\/struct>/s;
	($bid,$eid)=$param[0]=~/(\d+)-(\d+)/;
	if($cid ne ''){
		&PrintError(3) if(!$bid || !$eid || $cid!~/^\d+$/);
		&UserCheck($bid,$param[1],$param[2]);
		$dbh=DBI->connect("dbi:SQLite:dbname=entry/$bid.db");
		$sth=$dbh->prepare("select CategoryId from EntryList where EntryId=$eid");
		$sth->execute;
		$ref=$sth->fetch;
		$ocid=$ref->[0]||0;
		$sth->finish;
		$dbh->do("update EntryList set CategoryId=$cid where EntryId=$eid");
		$dbh->disconnect;
		if($cid!=$ocid){
			&CategoryUpdate($bid,$cid,$ocid);
			&Reconstruction($bid);
		}
	}
	$res=<<"EOF";
<?xml version="1.0" encoding="UTF-8"?>
<methodResponse>
<params><param><value><boolean>1</boolean></value></param></params>
</methodResponse>
EOF
	&PrintResponse($res);
}
###
sub getPostCategories{
	my($bid,$eid,@param,$dbh,$sth,$ref,$list,$res,%cate);	
	while($_[0]=~/<param>\s*<value>\s*<[^>]+>\s*([^<]*?)\s*<\/[^>]+>\s*<\/value>\s*<\/param>/g){
		push(@param,$1);
	}
	($bid,$eid)=$param[0]=~/(\d+)-(\d+)/;
	&PrintError(3) if(!$bid || !$eid);
	&UserCheck($bid,$param[1],$param[2]);
	%cate=&CategoryHash($bid);
	$dbh=DBI->connect("dbi:SQLite:dbname=entry/$bid.db");
	$sth=$dbh->prepare("select CategoryId from EntryList where EntryId=$eid");
	$sth->execute;
	if($ref=$sth->fetch){
		$cate{$ref->[0]}='no name' if(!$cate{$ref->[0]});
		$list.="<value><struct>";
		$list.="<member><name>categoryName</name><value><string>$cate{$ref->[0]}</string></value></member>";
		$list.="<member><name>categoryId</name><value><string>$ref->[0]</string></value></member>";
		$list.="<member><name>isPrimary</name><value><boolean>1</boolean></value></member>";
		$list.="</struct></value>\n";
	}
	$sth->finish;
	$dbh->disconnect;
	&PrintError(4) if(!$list);
	$res=<<"EOF";
<?xml version="1.0" encoding="UTF-8"?>
<methodResponse>
<params><param><value><array><data>\n$list</data></array></value></param></params>
</methodResponse>
EOF
	&PrintResponse($res);
}
###
sub getRecentPostTitles{
	my(@param,$dbh,$sth,$ref,@date,$list,$res);	
	while($_[0]=~/<param>\s*<value>\s*<[^>]+>\s*([^<]*?)\s*<\/[^>]+>\s*<\/value>\s*<\/param>/g){
		push(@param,$1);
	}
	&PrintError(3) if(!$param[3] || $param[3]=~/\D/);
	&UserCheck($param[0],$param[1],$param[2]);
	$dbh=DBI->connect("dbi:SQLite:dbname=entry/$param[0].db");
	$sth=$dbh->prepare("select PublisheDate,EntryId,EntryTitle from EntryList order by EntryId desc limit $param[3]");
	$sth->execute;
	while($ref=$sth->fetchrow_hashref){
		@date=$ref->{PublisheDate}=~/(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})/;
		&MetaEscape::html(\$ref->{EntryBody});
		&MetaEscape::html(\$ref->{EntryMore});
		$list.="<value><struct>";
		$list.="<member><name>dateCreated</name><value><dateTime.iso8601>$date[0]-$date[1]-$date[2]T$date[3]:$date[4]:$date[5]$TimeZone</dateTime.iso8601></value></member>";
		$list.="<member><name>userid</name><value><string>$param[1]</string></value></member>";
		$list.="<member><name>postid</name><value><string>$param[0]-$ref->{EntryId}</string></value></member>";
		$list.="<member><name>title</name><value><string>$ref->{EntryTitle}</string></value></member>";
		$list.="</struct></value>\n";
	}
	$sth->finish;
	$dbh->disconnect;
	$res=<<"EOF";
<?xml version="1.0" encoding="UTF-8"?>
<methodResponse>
<params><param><value><array><data>\n$list</data></array></value></param></params>
</methodResponse>
EOF
	&PrintResponse($res);
}
###
sub getRecentPosts{
	my(@param,$dbh,$sth,$ref,$ut,$bt,@date,$list,$url,$res);	
	while($_[0]=~/<param>\s*<value>\s*<[^>]+>\s*([^<]*?)\s*<\/[^>]+>\s*<\/value>\s*<\/param>/g){
		push(@param,$1);
	}
	&PrintError(3) if(!$param[3] || $param[3]=~/\D/);
	&UserCheck($param[0],$param[1],$param[2]);
	($bt,$ut)=&UrlInfo($param[0]);
	$dbh=DBI->connect("dbi:SQLite:dbname=entry/$param[0].db");
	$sth=$dbh->prepare("select PublisheDate,EntryId,EntryBody,EntryMore,EntryTitle from EntryList order by EntryId desc limit $param[3]");
	$sth->execute;
	while($ref=$sth->fetchrow_hashref){
		$url=&UrlMake::make($param[0],$bt,$ut,"type=entry,eid=$ref->{EntryId}");
		@date=$ref->{PublisheDate}=~/(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})/;
		&MetaEscape::html(\$ref->{EntryBody});
		&MetaEscape::html(\$ref->{EntryMore});
		$list.="<value><struct>";
		$list.="<member><name>dateCreated</name><value><dateTime.iso8601>$date[0]-$date[1]-$date[2]T$date[3]:$date[4]:$date[5]$TimeZone</dateTime.iso8601></value></member>";
		$list.="<member><name>userid</name><value><string>$param[1]</string></value></member>";
		$list.="<member><name>postid</name><value><string>$param[0]-$ref->{EntryId}</string></value></member>";
		$list.="<member><name>description</name><value><string>$ref->{EntryBody}</string></value></member>";
		$list.="<member><name>title</name><value><string>$ref->{EntryTitle}</string></value></member>";
		$list.="<member><name>link</name><value><string>$url</string></value></member>";
		$list.="<member><name>permaLink</name><value><string>$url</string></value></member>";
		$list.="<member><name>mt_text_more</name><value><string>$ref->{EntryMore}</string></value></member>";
		$list.="</struct></value>\n";
	}
	$sth->finish;
	$dbh->disconnect;
	$res=<<"EOF";
<?xml version="1.0" encoding="UTF-8"?>
<methodResponse>
<params><param><value><array><data>\n$list</data></array></value></param></params>
</methodResponse>
EOF
	&PrintResponse($res);
}
###
sub getUsersBlogs{
	my(@param,@param2,$dbh,$sth,$ref,$list,$res);	
	while($_[0]=~/<param>\s*<value>(.+?)<\/value>\s*<\/param>/sg){
		push(@param2,$1);
	}
	for(0..2){
		($param[$_])=$param2[$_]=~/<[^>]+>\s*([^<]*?)\s*<\/[^>]+>/;
	}
	&PrintError(3) if($param[1]=~/'/ || $param[2]=~/'/);
	$dbh=DBI->connect("dbi:SQLite:dbname=bloglist.db");
	$sth=$dbh->prepare("select BlogId,BlogName,BlogTop from BlogList where XmlRpc='$param[1]\@$param[2]'");
	$sth->execute;
	while($ref=$sth->fetch){
		next if($ref->[2]!~/^http/);
		$ref->[1]=$ref->[2] if(!$ref->[1]);
		$list.="<value><struct>";
		$list.="<member><name>url</name><value><string>$ref->[2]</string></value></member>";
		$list.="<member><name>blogid</name><value><string>$ref->[0]</string></value></member>";
		$list.="<member><name>blogName</name><value><string>$ref->[1]</string></value></member>";
		$list.="</struct></value>\n";
	}
	$sth->finish;
	$dbh->disconnect;
	&PrintError(1) if(!$list);
	$res=<<"EOF";
<?xml version="1.0" encoding="UTF-8"?>
<methodResponse>
<params><param><value><array><data>\n$list</data></array></value></param></params>
</methodResponse>
EOF
	&PrintResponse($res);
}
###
sub getCategoryList{
	my(@param,$dbh,$sth,$ref,@list,@line,$list,$res);	
	while($_[0]=~/<param>\s*<value>\s*<string>\s*([^<]*?)\s*<\/string>\s*<\/value>\s*<\/param>/g){
		push(@param,$1);
	}
	&UserCheck($param[0],$param[1],$param[2]);
	$dbh=DBI->connect("dbi:SQLite:dbname=bloglist.db");
	$sth=$dbh->prepare("select CategoryList from BlogList where BlogId=$param[0]");
	$sth->execute;
	$ref=$sth->fetch;
	@list=split(/,/,$ref->[0]);
	$sth->finish;
	$dbh->disconnect;
	push(@list,0) if($#list==-1);
	foreach(@list){
		@line=split(/:/,$_,3);
		$line[2]='no name' if(!$line[2]);
		$list.="<value><struct>";
		$list.="<member><name>categoryId</name><value><string>$line[0]</string></value></member>";
		$list.="<member><name>categoryName</name><value><string>$line[2]</string></value></member>";
		$list.="</struct></value>\n";
	}
	$res=<<"EOF";
<?xml version="1.0" encoding="UTF-8"?>
<methodResponse>
<params><param><value><array><data>\n$list</data></array></value></param></params>
</methodResponse>
EOF
	&PrintResponse($res);
}
###
sub CategoryHash{
	my($bid,$dbh,$sth,$ref,@list,@line,%hash);
	$bid=shift;
	$dbh=DBI->connect("dbi:SQLite:dbname=bloglist.db");
	$sth=$dbh->prepare("select CategoryList from BlogList where BlogId=$bid");
	$sth->execute;
	$ref=$sth->fetch;
	@list=split(/,/,$ref->[0]);
	$sth->finish;
	$dbh->disconnect;
	push(@list,0) if($#list==-1);
	foreach(@list){
		@line=split(/:/,$_,3);
		$line[2]='no name' if(!$line[2]);
		$hash{$line[0]}=$line[2];
	}
	return(%hash);
}
###
sub CategoryUpdate{
	my($bid,@cid,$cid,%count,@list,@line,$list,$dbh,$sth,$ref);
	$bid=shift;
	@cid=@_;
	$dbh=DBI->connect("dbi:SQLite:dbname=entry/$bid.db");
	foreach $cid(@cid){
		$sth=$dbh->prepare("select count(EntryId) from EntryList where CategoryId=$cid");
		$sth->execute;
		$ref=$sth->fetch;
		$count{$cid}=$ref->[0];
		$sth->finish;
	}
	$dbh->disconnect;
	$dbh=DBI->connect("dbi:SQLite:dbname=bloglist.db");
	$sth=$dbh->prepare("select CategoryList from BlogList where BlogId=$bid");
	$sth->execute;
	$ref=$sth->fetch;
	@list=split(/,/,$ref->[0]);
	$sth->finish;
	foreach(@list){
		@line=split(/:/,$_,3);
		$line[1]=$count{$line[0]} if(exists($count{$line[0]}));
		$list.="," if($list);
		$list.="$line[0]:$line[1]:$line[2]";
	}
	$dbh->do("update BlogList set CategoryList='$list' where BlogId=$bid");
	$dbh->disconnect;
}
###
sub StringCut{
	my($ref,$len);
	($ref,$len)=@_;
	return if(length($$ref)<=$len);
	$$ref=substr($$ref,0,$len-3);
	while(1){
		last if(!length($$ref));
		if($$ref=~/[\x00-\x7f]$/){
			$$ref=~s/&#?\w*$//;
			last;
		}
		if($$ref=~/[\xc0-\xef]$/){
			chop($$ref);
			last;
		}
		chop($$ref);
	}
	$$ref.='...';
}
###
sub EntryUpdate{
	my($bid,$eid,$cid,$title,$body,$more,@time,@now,$dbh,$sth,$ref,$count,$mon,$day,$summary);
	$bid=shift;
	$eid=shift;
	$cid=shift || 0;
	$title=shift;
	$body=shift;
	$more=shift;

	@time=localtime;
	$now[0]=$time[5]+1900;
	$now[1]=$time[4]+1;
	$now[2]=$time[3];
	$now[3]=$time[2];
	$now[4]=$time[1];
	$now[5]=$time[0];
	for(1..5){
		$now[$_]='0'.$now[$_] if(length($now[$_])==1);
	}
	@date=@now;
	$mon=$date[0].$date[1];
	$day=$date[0].$date[1].$date[2];
	&MetaEscape::html(\$title);
	$summary=$body;
	&MetaEscape::sql(\$body);
	&MetaEscape::sql(\$more);
	$summary=~s/<[sS][cC][rR][iI][pP][tT][^>]*>.*?<\/[sS][cC][rR][iI][pP][tT]>/ /gs;
	$summary=~s/<[^>]*>/ /g;
	$summary=~s/\s+/ /g;
	$summary=~s/^\s+//;
	$summary=~s/\s+$//;
	&MetaEscape::html(\$summary);
	&StringCut(\$summary,255);
	$dbh=DBI->connect("dbi:SQLite:dbname=entry/$bid.db");
	if(!$eid){
		$dbh->do("insert into EntryList(EntryTitle,EntryBody,EntryMore,CategoryId,Summary,PublisheDate,EntryTime,CommentCount,TrackbackCount,EntryMonth,EntryDate) values('$title','$body','$more',$cid,'$summary',".join('',@now).",".join('',@date).",0,0,$mon,$day)");
		$sth=$dbh->prepare("select seq from sqlite_sequence");
		$sth->execute;
		$ref=$sth->fetch;
		$eid=$ref->[0];
		$sth->finish;
	}else{
		$dbh->do("update EntryList set EntryTitle='$title',EntryBody='$body',EntryMore='$more',CategoryId=$cid,Summary='$summary' where EntryId=$eid");
	}
	$sth=$dbh->prepare("select count(EntryId) from EntryList");
	$sth->execute;
	$ref=$sth->fetch;
	$count=$ref->[0];
	$sth->finish;
	$dbh->disconnect;
	$dbh=DBI->connect("dbi:SQLite:dbname=bloglist.db");
	$dbh->do("update BlogList set EntryCount=$count where BlogId=$bid");
	$dbh->disconnect;
	&Reconstruction($bid);
	return($eid);
}
###
sub UserCheck{
	my($bid,$name,$pass,$dbh,$sth,$ref,$res);
	($bid,$name,$pass)=@_;
	&PrintError(3) if($bid=~/\D/);
	$dbh=DBI->connect("dbi:SQLite:dbname=bloglist.db");
	$sth=$dbh->prepare("select XmlRpc from BlogList where BlogId=$bid");
	$sth->execute;
	$ref=$sth->fetch;
	$res=1 if($ref->[0] eq "$name\@$pass");
	$sth->finish;
	$dbh->disconnect;
	&PrintError(2) if(!$res);
}
###
sub UrlInfo{
	my($dbh,$sth,$ref,$bt,$ut);
	$dbh=DBI->connect("dbi:SQLite:dbname=bloglist.db");
	$sth=$dbh->prepare("select UrlType,BlogTop from BlogList where BlogId=$_[0]");
	$sth->execute;
	$ref=$sth->fetch;
	$ut=$ref->[0];
	$bt=$ref->[1];
	$sth->finish;
	$dbh->disconnect;
	return($bt,$ut);
}
###
sub Reconstruction{
	open(FILE,"+>cache/reconstruction.$_[0].dat");
	print FILE "1";
	close(FILE);
}
###
sub PrintResponse{
	print "content-type:text/xml\n\n";
	print "$_[0]";
	exit;
}
###
sub PrintError{
	print "content-type:text/xml\n\n";
	print <<"EOF";
<?xml version="1.0"?>
<methodResponse>
<fault><value><struct>
<member><name>faultCode</name><value><int>$_[0]</int></value></member>
<member><name>faultString</name><value><string>$ErrorMessage{$_[0]}</string></value></member>
</struct></value></fault>
</methodResponse>
EOF
	exit;

}
###

